/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Decimal.xs. Do not edit this file, edit Decimal.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Math/Decimal.xs"
#define PERL_NO_GET_CONTEXT 1
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#define PERL_DECIMAL_VERSION \
	PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#define PERL_VERSION_GE(r,v,s) \
	(PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))

#if !PERL_VERSION_GE(5,7,2)
# undef dNOOP
# define dNOOP extern int Perl___notused_func(void)
#endif /* <5.7.2 */

#ifndef newSVpvs
# define newSVpvs(string) newSVpvn(""string"", sizeof(string)-1)
#endif /* !newSVpvs */

#if PERL_VERSION_GE(5,7,3)
# define PERL_UNUSED_THX() NOOP
#else /* <5.7.3 */
# define PERL_UNUSED_THX() ((void)(aTHX+0))
#endif /* <5.7.3 */

/* parameter classification */

#define sv_is_glob(sv) (SvTYPE(sv) == SVt_PVGV)

#if PERL_VERSION_GE(5,11,0)
# define sv_is_regexp(sv) (SvTYPE(sv) == SVt_REGEXP)
#else /* <5.11.0 */
# define sv_is_regexp(sv) 0
#endif /* <5.11.0 */

#define sv_is_string(sv) \
	(!sv_is_glob(sv) && !sv_is_regexp(sv) && \
	 (SvFLAGS(sv) & (SVf_IOK|SVf_NOK|SVf_POK|SVp_IOK|SVp_NOK|SVp_POK)))

/* fixed strings for important numbers */

static SV *signum_sv[3];

/* exceptions */

#define throw_not_decimal() croak("not a decimal number")

/*
 * decimal syntax handling
 *
 * The "decimal" structure represents a decimal number in a form slightly
 * abstracted from the API string form.  The sign is represented as the
 * "signum" member.  The two pairs of pointers delimit the digits of the
 * number, which must be stored in memory as ASCII digits.  The integer
 * and fractional digits are stored separately, which is a pain to handle
 * but means that the digits can actually be stored in an input SV, where
 * there's a '.' between the groups of digits.  Either group of digits
 * may be empty (foo_start == foo_end).  In the general case, there may
 * be superfluous leading or trailing zeroes in the number.
 *
 * The read_canonical() function takes an input SV and parses it into
 * "struct decimal" form.  The resulting structure points into the SV,
 * which must therefore stay alive while the number is being processed.
 * The number is fully trimmed as it is parsed: it is guaranteed to have
 * no leading or trailing zero digits.  If the input SV is not of valid
 * form, an exception is thrown.
 *
 * The canonical_write() function takes a "struct decimal" and
 * generates an SV expressing the number.  It will always generate valid
 * syntax, but it does not perform trimming.  To generate the output in
 * canonical form, as most functions require, the structure must already
 * be trimmed.
 *
 * The identity_canonical() function canonises a "struct decimal".  It trims
 * off leading and trailing zero digits, and will set signum to 0 if the
 * value is zero.
 */

struct decimal {
	int signum;
	char *int_start, *int_end;
	char *frac_start, *frac_end;
};

#define read_canonical(r, r_sv) THX_read_canonical(aTHX_ r, r_sv)
static void THX_read_canonical(pTHX_ struct decimal *r, SV *r_sv)
{
	STRLEN len;
	char *p, *end, c, *q;
	if(!sv_is_string(r_sv)) throw_not_decimal();
	p = SvPV(r_sv, len);
	end = p + len;
	c = *p;
	r->signum = c == '-' ? -1 : +1;
	if(c == '+' || c == '-') c = *++p;
	if(c < '0' || c > '9') throw_not_decimal();
	q = 0;
	do {
		if(!q && c != '0') q = p;
		c = *++p;
	} while(c >= '0' && c <= '9');
	r->int_start = q ? q : p;
	r->int_end = p;
	if(c == '.') {
		c = *++p;
		r->frac_start = q = p;
		if(c < '0' || c > '9') throw_not_decimal();
		do {
			p++;
			if(c != '0') q = p;
			c = *p;
		} while(c >= '0' && c <= '9');
		r->frac_end = q;
	} else {
		r->frac_start = p;
		r->frac_end = p;
	}
	if(p != end) throw_not_decimal();
	if(r->int_start == r->int_end && r->frac_start == r->frac_end)
		r->signum = 0;
}

#define canonical_write(r) THX_canonical_write(aTHX_ r)
static SV *THX_canonical_write(pTHX_ struct decimal *r)
{
	STRLEN len;
	char *p;
	SV *r_sv = newSVpvs("");
	len = (r->signum == -1) +
		(r->int_start==r->int_end ? 1 : r->int_end-r->int_start) +
		(r->frac_start==r->frac_end ? 0 :
			(r->frac_end-r->frac_start)+1);
	p = SvGROW(r_sv, len+1);
	SvCUR_set(r_sv, len);
	if(r->signum == -1) *p++ = '-';
	if(r->int_start == r->int_end) {
		*p++ = '0';
	} else {
		len = r->int_end - r->int_start;
		Copy(r->int_start, p, len, char);
		p += len;
	}
	if(r->frac_start != r->frac_end) {
		len = r->frac_end - r->frac_start;
		*p++ = '.';
		Copy(r->frac_start, p, len, char);
		p += len;
	}
	*p = 0;
	return r_sv;
}

static void identity_canonical(struct decimal *a)
{
	char *p, *q;
	for(p = a->int_start, q = a->int_end; p != q && *p == '0'; p++)
		;
	a->int_start = p;
	for(p = a->frac_end, q = a->frac_start; p != q && p[-1] == '0'; p--)
		;
	a->frac_end = p;
	if(a->int_start == a->int_end && a->frac_start == a->frac_end)
		a->signum = 0;
}

/*
 * arithmetic utilities
 *
 * A "canonical_" prefix indicates that the function requires trimmed
 * inputs.  A "_canonical" suffix indicates that the function generates
 * trimmed outputs.
 */

#define canonical_get_expt(a) THX_canonical_get_expt(aTHX_ a)
static int THX_canonical_get_expt(pTHX_ struct decimal *a)
{
	char *p, *q;
	int val;
	PERL_UNUSED_THX();
	if(a->frac_start != a->frac_end) croak("not an integer");
	p = a->int_start;
	q = a->int_end;
	if((q-p) > 9) croak("exponent too large");
	val = 0;
	while(p != q)
		val = val*10 + (*p++) - '0';
	return a->signum == -1 ? -val : +val;
}

static int canonical_cmp_magnitude(struct decimal *a, struct decimal *b)
{
	STRLEN al, bl;
	char *ap, *bp;
	al = a->int_end - a->int_start;
	bl = b->int_end - b->int_start;
	if(al != bl) return al < bl ? -1 : +1;
	for(ap=a->int_start, bp=b->int_start; ap != a->int_end; ap++, bp++) {
		char ac = *ap, bc = *bp;
		if(ac != bc) return ac < bc ? -1 : +1;
	}
	ap = a->frac_start;
	bp = b->frac_start;
	for(ap=a->frac_start, bp=b->frac_start; ; ap++, bp++) {
		if(ap == a->frac_end && bp == b->frac_end) {
			return 0;
		} else if(ap == a->frac_end) {
			return -1;
		} else if(bp == b->frac_end) {
			return +1;
		} else {
			char ac = *ap, bc = *bp;
			if(ac != bc) return ac < bc ? -1 : +1;
		}
	}
}

static int canonical_cmp_value(struct decimal *a, struct decimal *b)
{
	int as = a->signum, bs = b->signum;
	if(as != bs) {
		return as < bs ? -1 : +1;
	} else if(as == 0) {
		return 0;
	} else if(as == +1) {
		return canonical_cmp_magnitude(a, b);
	} else {
		return canonical_cmp_magnitude(b, a);
	}
}

#define canonical_add_magnitude(r, a, b) \
	THX_canonical_add_magnitude(aTHX_ r, a, b)
static void THX_canonical_add_magnitude(pTHX_ struct decimal *r,
	struct decimal *a, struct decimal *b)
{
	int carry;
	char *ap, *bp, *rp;
	STRLEN ali = a->int_end - a->int_start;
	STRLEN bli = b->int_end - b->int_start;
	STRLEN rli = 1 + (ali > bli ? ali : bli);
	STRLEN sli = ali < bli ? ali : bli;
	STRLEN alf = a->frac_end - a->frac_start;
	STRLEN blf = b->frac_end - b->frac_start;
	STRLEN rlf = alf > blf ? alf : blf;
	STRLEN slf = alf < blf ? alf : blf;
	SV *digstore = sv_2mortal(newSVpvs(""));
	r->int_start = SvGROW(digstore, rli+rlf+1);
	SvCUR_set(digstore, rli+rlf);
	r->frac_start = r->int_end = r->int_start + rli;
	rp = r->frac_end = r->frac_start + rlf;
	*rp = 0;
	ap = a->frac_end;
	bp = b->frac_end;
	if(alf < blf) {
		STRLEN xl = blf - alf;
		bp -= xl;
		rp -= xl;
		Copy(bp, rp, xl, char);
	} else if(alf > blf) {
		STRLEN xl = alf - blf;
		ap -= xl;
		rp -= xl;
		Copy(ap, rp, xl, char);
	}
	carry = 0;
	while(slf-- != 0) {
		char rc = *--ap + *--bp + carry - '0';
		carry = rc > '9';
		if(carry) rc -= 10;
		*--rp = rc;
	}
	rp = r->int_end;
	ap = a->int_end;
	bp = b->int_end;
	while(sli-- != 0) {
		char rc = *--ap + *--bp + carry - '0';
		carry = rc > '9';
		if(carry) rc -= 10;
		*--rp = rc;
	}
	if(ali > bli) {
		ali -= bli;
		while(ali-- != 0) {
			char rc = *--ap + carry;
			carry = rc > '9';
			if(carry) rc -= 10;
			*--rp = rc;
		}
	} else if(bli > ali) {
		bli -= ali;
		while(bli-- != 0) {
			char rc = *--bp + carry;
			carry = rc > '9';
			if(carry) rc -= 10;
			*--rp = rc;
		}
	}
	*--rp = '0' + carry;
}

#define canonical_sub_magnitude(r, a, b) \
	THX_canonical_sub_magnitude(aTHX_ r, a, b)
static void THX_canonical_sub_magnitude(pTHX_ struct decimal *r,
	struct decimal *a, struct decimal *b)
{
	int carry;
	char *ap, *bp, *rp;
	STRLEN ali = a->int_end - a->int_start;
	STRLEN bli = b->int_end - b->int_start;
	STRLEN rli = ali > bli ? ali : bli;
	STRLEN sli = ali < bli ? ali : bli;
	STRLEN alf = a->frac_end - a->frac_start;
	STRLEN blf = b->frac_end - b->frac_start;
	STRLEN rlf = alf > blf ? alf : blf;
	STRLEN slf = alf < blf ? alf : blf;
	SV *digstore = sv_2mortal(newSVpvs(""));
	r->int_start = SvGROW(digstore, rli+rlf+1);
	SvCUR_set(digstore, rli+rlf);
	r->frac_start = r->int_end = r->int_start + rli;
	rp = r->frac_end = r->frac_start + rlf;
	*rp = 0;
	ap = a->frac_end;
	bp = b->frac_end;
	carry = 0;
	if(alf < blf) {
		while(blf-- != alf) {
			*--rp = '0' - *--bp - carry + '0' + 10;
			carry = 1;
		}
	} else if(alf > blf) {
		STRLEN xl = alf - blf;
		ap -= xl;
		rp -= xl;
		Copy(ap, rp, xl, char);
	}
	while(slf-- != 0) {
		char rc = *--ap - *--bp - carry + '0';
		carry = rc < '0';
		if(carry) rc += 10;
		*--rp = rc;
	}
	rp = r->int_end;
	ap = a->int_end;
	bp = b->int_end;
	while(sli-- != 0) {
		char rc = *--ap - *--bp - carry + '0';
		carry = rc < '0';
		if(carry) rc += 10;
		*--rp = rc;
	}
	ali -= bli;
	while(ali-- != 0) {
		char rc = *--ap - carry;
		carry = rc < '0';
		if(carry) rc += 10;
		*--rp = rc;
	}
}

#define canonical_mul_value(r, a, b) THX_canonical_mul_value(aTHX_ r, a, b)
static void THX_canonical_mul_value(pTHX_ struct decimal *r,
	struct decimal *a, struct decimal *b)
{
	STRLEN ali = a->int_end - a->int_start;
	STRLEN bli = b->int_end - b->int_start;
	STRLEN alf = a->frac_end - a->frac_start;
	STRLEN blf = b->frac_end - b->frac_start;
	SV *digstore = sv_2mortal(newSVpvs(""));
	char *ds, *de, *bp;
	r->signum = a->signum == b->signum ? +1 : -1;
	r->int_start = ds = SvGROW(digstore, ali+bli+alf+blf+1);
	SvCUR_set(digstore, ali+bli+alf+blf);
	r->frac_start = r->int_end = ds + ali+bli;
	r->frac_end = de = ds + ali+bli+alf+blf;
	memset(ds, '0', de-ds);
	*de = 0;
	for(bp = b->frac_end; ; de--) {
		int bmul, carry;
		char *rp, *ap;
		if(bp == b->frac_start) bp = b->int_end;
		if(bp == b->int_start) break;
		bmul = *--bp - '0';
		if(bmul == 0) continue;
		rp = de;
		carry = 0;
		for(ap = a->frac_end; ; ) {
			int v;
			if(ap == a->frac_start) ap = a->int_end;
			if(ap == a->int_start) break;
			v = (*--ap - '0') * bmul + carry + (*--rp - '0');
			*rp = (v % 10) + '0';
			carry = v/10;
		}
		while(carry) {
			int v = carry + (*--rp - '0');
			*rp = (v % 10) + '0';
			carry = v/10;
		}
	}
}

#line 413 "lib/Math/Decimal.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 557 "lib/Math/Decimal.c"

XS_EUPXS(XS_Math__Decimal_is_dec_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_is_dec_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "arg");
    {
#line 423 "lib/Math/Decimal.xs"
	STRLEN len;
	char *p, *end, c;
#line 569 "lib/Math/Decimal.c"
	bool	RETVAL;
	SV *	arg = ST(0)
;
#line 426 "lib/Math/Decimal.xs"
	RETVAL = 0;
	if(!sv_is_string(arg)) goto out;
	p = SvPV(arg, len);
	end = p + len;
	c = *p;
	if(c == '+' || c == '-') c = *++p;
	if(c < '0' || c > '9') goto out;
	do {
		c = *++p;
	} while(c >= '0' && c <= '9');
	if(c == '.') {
		c = *++p;
		if(c < '0' || c > '9') goto out;
		do {
			c = *++p;
		} while(c >= '0' && c <= '9');
	}
	if(p != end) goto out;
	RETVAL = 1;
	out: ;
#line 594 "lib/Math/Decimal.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_check_dec_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_check_dec_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 453 "lib/Math/Decimal.xs"
	struct decimal a;
#line 610 "lib/Math/Decimal.c"
	SV *	a_sv = ST(0)
;
#line 455 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
#line 615 "lib/Math/Decimal.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Decimal_dec_canonise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_canonise)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 461 "lib/Math/Decimal.xs"
	struct decimal a;
#line 630 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
#line 463 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	RETVAL = canonical_write(&a);
#line 637 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_sgn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_sgn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 472 "lib/Math/Decimal.xs"
	struct decimal a;
#line 654 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
#line 474 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	RETVAL = SvREFCNT_inc(signum_sv[1 + a.signum]);
#line 661 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_abs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 483 "lib/Math/Decimal.xs"
	struct decimal a;
#line 678 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
#line 485 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	if(a.signum == -1) a.signum = +1;
	RETVAL = canonical_write(&a);
#line 686 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 495 "lib/Math/Decimal.xs"
	struct decimal a, b;
	int result;
#line 704 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 498 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	result = canonical_cmp_value(&a, &b);
	RETVAL = SvREFCNT_inc(signum_sv[1 + result]);
#line 715 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_min)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 509 "lib/Math/Decimal.xs"
	struct decimal a, b;
#line 732 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 511 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	RETVAL = canonical_write(canonical_cmp_value(&a, &b) == -1 ? &a : &b);
#line 742 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 521 "lib/Math/Decimal.xs"
	struct decimal a, b;
#line 759 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 523 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	RETVAL = canonical_write(canonical_cmp_value(&a, &b) == +1 ? &a : &b);
#line 769 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_neg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 533 "lib/Math/Decimal.xs"
	struct decimal a;
#line 786 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
#line 535 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	a.signum = -a.signum;
	RETVAL = canonical_write(&a);
#line 794 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 545 "lib/Math/Decimal.xs"
	struct decimal a, b;
#line 811 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 547 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	if(a.signum == 0) {
		RETVAL = canonical_write(&b);
	} else if(b.signum == 0) {
		RETVAL = canonical_write(&a);
	} else if(a.signum == b.signum) {
		/* same sign, add magnitudes */
		struct decimal r;
		r.signum = a.signum;
		canonical_add_magnitude(&r, &a, &b);
		identity_canonical(&r);
		RETVAL = canonical_write(&r);
	} else {
		/* different sign, subtract magnitudes */
		int cmp = canonical_cmp_magnitude(&a, &b);
		if(cmp == +1) {
			struct decimal r;
			r.signum = a.signum;
			canonical_sub_magnitude(&r, &a, &b);
			identity_canonical(&r);
			RETVAL = canonical_write(&r);
		} else if(cmp == -1) {
			struct decimal r;
			r.signum = b.signum;
			canonical_sub_magnitude(&r, &b, &a);
			identity_canonical(&r);
			RETVAL = canonical_write(&r);
		} else {
			RETVAL = newSVpvs("0");
		}
	}
#line 850 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_sub)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 586 "lib/Math/Decimal.xs"
	struct decimal a, b;
#line 867 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 588 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	if(a.signum == 0) {
		b.signum = -b.signum;
		RETVAL = canonical_write(&b);
	} else if(b.signum == 0) {
		RETVAL = canonical_write(&a);
	} else if(a.signum != b.signum) {
		/* different sign, add magnitudes */
		struct decimal r;
		r.signum = a.signum;
		canonical_add_magnitude(&r, &a, &b);
		identity_canonical(&r);
		RETVAL = canonical_write(&r);
	} else {
		/* same sign, subtract magnitudes */
		int cmp = canonical_cmp_magnitude(&a, &b);
		if(cmp == +1) {
			struct decimal r;
			r.signum = a.signum;
			canonical_sub_magnitude(&r, &a, &b);
			identity_canonical(&r);
			RETVAL = canonical_write(&r);
		} else if(cmp == -1) {
			struct decimal r;
			r.signum = -b.signum;
			canonical_sub_magnitude(&r, &b, &a);
			identity_canonical(&r);
			RETVAL = canonical_write(&r);
		} else {
			RETVAL = newSVpvs("0");
		}
	}
#line 907 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_pow10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_pow10)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a_sv");
    {
#line 628 "lib/Math/Decimal.xs"
	struct decimal a;
	int expt;
	char *p;
#line 926 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
#line 632 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	expt = canonical_get_expt(&a);
	if(expt < 0) {
		RETVAL = newSVpvs("");
		p = SvGROW(RETVAL, (STRLEN)(3-expt));
		SvCUR_set(RETVAL, (STRLEN)(2-expt));
		p[0] = '0';
		p[1] = '.';
		memset(p+2, '0', -1-expt);
		p[1-expt] = '1';
		p[2-expt] = 0;
	} else {
		RETVAL = newSVpvs("");
		p = SvGROW(RETVAL, (STRLEN)(2+expt));
		SvCUR_set(RETVAL, (STRLEN)(1+expt));
		p[0] = '1';
		memset(p+1, '0', expt);
		p[1+expt] = 0;
	}
#line 950 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_mul_pow10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_mul_pow10)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 658 "lib/Math/Decimal.xs"
	struct decimal a, b;
	int expt;
#line 968 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 661 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	expt = canonical_get_expt(&b);
	if(a.signum == 0 || b.signum == 0) {
		RETVAL = canonical_write(&a);
	} else if(expt < 0) {
		struct decimal r;
		SV *digstore = sv_2mortal(newSVpvs(""));
		STRLEN ali = a.int_end - a.int_start;
		STRLEN alf = a.frac_end - a.frac_start;
		STRLEN lx = ali >= (STRLEN)-expt ? 0 : -expt - ali;
		char *p;
		p = SvGROW(digstore, lx+ali+alf+1);
		SvCUR_set(digstore, lx+ali+alf);
		memset(p, '0', lx);
		Copy(a.int_start, p+lx, ali, char);
		Copy(a.frac_start, p+lx+ali, alf, char);
		p[lx+ali+alf] = 0;
		r.signum = a.signum;
		r.int_start = p;
		r.frac_start = r.int_end = p+lx+ali+expt;
		r.frac_end = p+lx+ali+alf;
		identity_canonical(&r);
		RETVAL = canonical_write(&r);
	} else {
		struct decimal r;
		SV *digstore = sv_2mortal(newSVpvs(""));
		STRLEN ali = a.int_end - a.int_start;
		STRLEN alf = a.frac_end - a.frac_start;
		STRLEN lx = alf >= (STRLEN)expt ? 0 : expt - alf;
		char *p;
		p = SvGROW(digstore, ali+alf+lx+1);
		SvCUR_set(digstore, ali+alf+lx);
		Copy(a.int_start, p, ali, char);
		Copy(a.frac_start, p+ali, alf, char);
		memset(p+ali+alf, '0', lx);
		p[ali+alf+lx] = 0;
		r.signum = a.signum;
		r.int_start = p;
		r.frac_start = r.int_end = p+ali+expt;
		r.frac_end = p+ali+alf+lx;
		identity_canonical(&r);
		RETVAL = canonical_write(&r);
	}
#line 1019 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Decimal_dec_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Decimal_dec_mul)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a_sv, b_sv");
    {
#line 712 "lib/Math/Decimal.xs"
	struct decimal a, b, r;
#line 1036 "lib/Math/Decimal.c"
	SV *	RETVAL;
	SV *	a_sv = ST(0)
;
	SV *	b_sv = ST(1)
;
#line 714 "lib/Math/Decimal.xs"
	read_canonical(&a, a_sv);
	read_canonical(&b, b_sv);
	canonical_mul_value(&r, &a, &b);
	identity_canonical(&r);
	RETVAL = canonical_write(&r);
#line 1048 "lib/Math/Decimal.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Decimal); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Decimal)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Math::Decimal::is_dec_number", XS_Math__Decimal_is_dec_number, file, "$");
        (void)newXSproto_portable("Math::Decimal::check_dec_number", XS_Math__Decimal_check_dec_number, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_canonise", XS_Math__Decimal_dec_canonise, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_sgn", XS_Math__Decimal_dec_sgn, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_abs", XS_Math__Decimal_dec_abs, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_cmp", XS_Math__Decimal_dec_cmp, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_min", XS_Math__Decimal_dec_min, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_max", XS_Math__Decimal_dec_max, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_neg", XS_Math__Decimal_dec_neg, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_add", XS_Math__Decimal_dec_add, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_sub", XS_Math__Decimal_dec_sub, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_pow10", XS_Math__Decimal_dec_pow10, file, "$");
        (void)newXSproto_portable("Math::Decimal::dec_mul_pow10", XS_Math__Decimal_dec_mul_pow10, file, "$$");
        (void)newXSproto_portable("Math::Decimal::dec_mul", XS_Math__Decimal_dec_mul, file, "$$");

    /* Initialisation Section */

#line 408 "lib/Math/Decimal.xs"
	signum_sv[0] = newSVpvs("-1");
	signum_sv[1] = newSVpvs("0");
	signum_sv[2] = newSVpvs("1");
	{
		int i;
		for(i = 3; i--; ) {
			(void)SvIV(signum_sv[i]);
			SvREADONLY_on(signum_sv[i]);
		}
	}

#line 1112 "lib/Math/Decimal.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
